原题链接
1 题目
1.1 题目所需求出内容
对于本题,最终要求:可行性
1.2 题目背景、允许、禁止与限制
背景:
有 nnn 块地砖,第 iii 块地砖有一个深度 fif_ifi
有 bbb 双靴子,其中每一双靴子有两个信息 (si,di)(s_i,d_i)(si ,di ),分别代表靴子的最大深度及最远跳跃距离
允许:
对于每双靴子,检查其是否能从第 111 块地砖走到第 nnn 块(只能踩在 si<fis_i<f_isi <fi 的地砖上且每次至多前进 did_idi 步)
1.3 题目数据范围与猜测
n,b≤105→O(b log n)n,b\le10^5\to O(b~log~n)n,b≤105→O(b log n)
1.4 一句话概括题意
有 nnn 个点,每个点有一个值,对于每个给定信息,检查其跳跃距离与积雪承受深度能否使其从 111 跳到 nnn
2 题目破题推导
2.1 第一步:正向思维转逆向思维
正向思维:
对每个靴子都尝试走一遍地砖,时间复杂度 O(nb)O(nb)O(nb)
逆向思维:
简化一下问题可以解释成:对于每双鞋 (di,si)(d_i,s_i)(di ,si ),检查序列 fff 中是否存在一段 ≥di\ge d_i≥di 且 >si>s_i>si 的连续区间
2.2 第二步:单调性思考
关键点:连续段落的长度
考虑单调性:深度更小的鞋,这个连续区间就一定 ≥\ge≥ 深度更大的鞋
因此维护完深度更大的鞋子的连续段落后,深度更小的鞋一定是在连续段落的基础上扩展
3 模型匹配
既然有了单调性,肯定先维护深度更大的鞋子(排序\huge{排序}排序)
在所有段落在当前基础上扩展(并查集\huge{并查集}并查集)对于新的鞋,每当产生一个新的不能踩的点,与其相邻两个节点(是位置相邻而非大小关系相邻)合并,如果左右都没有,那就是一个距离为 111 的连续区间。而如果某一边有,就是合并左右两边并且更新最长距离
为了辅助并查集,需要按点的深度从大到小排序,这样当前能不能踩的状态一定由上一双靴子最后一个能踩的点往后延伸(保证每双鞋不用单独扫描一遍)
并且因为有了单调性,所以复杂度是 O(n log n+(n+b)+n(α(n)))O(n~log~n+(n+b)+n(\alpha(n)))O(n log n+(n+b)+n(α(n)))
4 最终代码(禁止抄袭,仅用于参考)
错误点:
有init,dfs_init等等初始化函数,一定不要忘记!
双指针(或类似实现方式)时不要忘记两个端点都判不越界